	@program	prog_code,prog_name

	include macros.h
;************** Start of Fargo program ***************
;
; WHAT DO THIS EXAMPLE :
;  You enter a file you want to search (with '*' and
;  '?') and the program print the 10 first 
;  finded files
;

prog_code:
	jsr	flib[clr_scr]

	move.w	#0100,d0
	jsr	tivatlib[CheckVersion]
	tst.w	d2
	beq	\badversion

	SetFont	#2
	WriteStr #50,#5,#1,title

	SetFont	#1
	WriteStr #5,#20,#1,txt1
	WriteStr #10,#30,#1,txt2
		
	move.w	#8,d1		;call the input routine
	move.w	#5,d2
	move.w	#45,d3
	lea	Buf(PC),a0
	bsr	Input
	tst.w	d0		;if ESC, exit
	beq	\exit

	jsr	tivatlib[FindFirst_Ext]	;search 1st file

	moveq.w	#7,d3			;8 files at max
	moveq.w	#50,d4			;Y start pos

\print	tst.w	d2			;if no file found
	beq	\exit			;exit !

	jsr	tivatlib[FileWithPath]	;return in a0 the path+file

	move.w	#4,-(a7)		;print on the screen
	move.l	a0,-(a7)
	move.w	d4,-(a7)
	move.w	#100,-(a7)
	jsr	romlib[puttext]
	lea	10(a7),a7

	add.w	#8,d4			;Y=Y+8
	jsr	tivatlib[FindNext_Ext]	;search for other file
	dbra	d3,\print


\exit	jsr	flib[idle_loop]


\badversion
	rts


;--------------------------------------------------------------------------
;Input
;
; (this function is quite badly programmed, but I made it )
; (a long time ago, and I don't want to make an other only)
; (for this small example                                 )
; 
;Input :	d1.w : Len of characters (max)
;		d2.w : X pos
;		d3.w : Y pos
;		a0 : address of the buffer where put
;		     the text.
;
;Return	:	d0.w=0 if ESC.
;		d0.w=nb of characters
;	DOESN'T CHANGE THE OTHER REGISTERS
;---------------------------------------------------------------------
	Input:

	movem.l	d5/a1,-(a7)
	clr.w	d5

	move.l	a0,a1

	move.b	#95,(a1)	;the '_' char
	clr.b	1(a1)
	bsr	Print_Txt

\WaitKey jsr	flib[idle_loop]

	cmp.w	#13,d0			; Enter ?
	beq	\enter
	cmp.w	#257,d0			; Backspace ?
	beq	\BackSp
	cmp.w	#264,d0			;ESC ?
	beq	\ESC

	cmp.w	#255,d0		;Valid character ?
	bhi	\WaitKey	;if not, loop

	cmp.w	d5,d1		;Max of characters ?
	beq	\WaitKey

	move.b	d0,(a1)+
	move.b	#95,(a1)	
	clr.b	1(a1)
	
	addq.w	#1,d5
	
	bsr 	Print_Txt
	bra	\WaitKey

\BackSp
	tst.w	d5
	beq	\WaitKey

	subq.w	#1,d5
	move.b	#32,(a1)	;Clear ' _ ' 
	clr.b	1(a1)
	move.b	#95,-(a1)	;Clear Charac
	
	bsr	Print_Txt

	bra	\WaitKey

\enter
	move.b	#32,(a1)
	clr.b	1(a1)
	jsr	Print_Txt
	clr.b	(a1)
	move.w	d5,d0
	bra	\end

\ESC	clr.w	d0

\end
	movem.l	(a7)+,d5/a1
	rts

Print_Txt:
	movem.l	d1-d2/a0-a1,-(a7)
	move.w	#4,-(a7)		;Color
	move.l	a0,-(a7)		;address
	move.w	d3,-(a7)		;Y
	move.w	d2,-(a7)		;X
	jsr	romlib[puttext]		;Print !
	lea	10(a7),a7		
	movem.l	(a7)+,d1-d2/a0-a1
	rts



;*****************************************************
; Program data
;*****************************************************

title	dc.b	"FIND EXAMPLE",0
txt1	dc.b	"Enter the file you are looking for",0
txt2	dc.b	"(with '?' and '*')",0

Buf	dcb.b	10,0

prog_name:
	dc.b	"Find EXAMPLE (for TIVATLIB)",0


;*************** End of Fargo program ****************

	reloc_open
	add_library	tivatlib
	add_library	romlib
	add_library	flib
	reloc_close
	end
